#include "Error.h"
#include "../Include/KSGScript.h"
#include <iostream>
#include <Text.h>

void KSGScript::error( int num, std::initializer_list< const char * > msg, KSGScript::KSGScriptProcessor *zObj )
{
    Framework::Text logMsg;
    switch( num )
    {
    case 0:
        logMsg = "Warnung: Fehler beim erstellen einer Variable.";
        break;
    case 1:
        logMsg = "Warnung: Eine Variable dieses Typs kann nicht erstellt werden.";
        break;
    case 2:
        logMsg = "Warnung: Eine Variable mit unbekanntem Typ kann nicht erstellt werden.";
        break;
    case 3:
        logMsg = "Warnung: NULL Zeiger beim ausfhren eines Operators.";
        break;
    case 4:
        logMsg = "Error: Die KSGScript Datei '";
        logMsg += msg.begin()[ 0 ];
        logMsg += "' konnte nicht geffnet werden.";
        break;
    case 5:
        logMsg = "Error: Die Datei '";
        logMsg += msg.begin()[ 0 ];
        logMsg += "' konnte nicht geladen werden. Unbekanntes Wort in Zeile '";
        logMsg += msg.begin()[ 1 ];
        logMsg += "'";
        break;
    case 6:
        logMsg = "Error: Eine '";
        logMsg += msg.begin()[ 0 ];
        logMsg += "' aus der Datei '";
        logMsg += msg.begin()[ 1 ];
        logMsg += "' konnte nicht gelesen werden.";
        break;
    case 7:
        logMsg = "Error: Compile Fehler in Datei '";
        logMsg += msg.begin()[ 0 ];
        logMsg += "' zeile '";
        logMsg += msg.begin()[ 1 ];
        logMsg += "' der Datentyp '";
        logMsg += msg.begin()[ 2 ];
        logMsg += "' ist bereits definiert.";
        break;
    case 8:
        logMsg = "Error: Compile Fehler in Datei '";
        logMsg += msg.begin()[ 0 ];
        logMsg += "' zeile '";
        logMsg += msg.begin()[ 1 ];
        logMsg += "' die Funktion '";
        logMsg += msg.begin()[ 2 ];
        logMsg += "' ist bereits definiert.";
        break;
    case 9:
        logMsg = "Error: Compile Fehler in Datei '";
        logMsg += msg.begin()[ 0 ];
        logMsg += "' zeile '";
        logMsg += msg.begin()[ 1 ];
        logMsg += "' die Variable '";
        logMsg += msg.begin()[ 2 ];
        logMsg += "' ist bereits definiert.";
        break;
    case 10:
        logMsg = "Error: Unbekannter Fehler beim Compile Vorgang.";
        break;
    case 11:
        logMsg = "Error: Compile Fehler in Datei '";
        logMsg += msg.begin()[ 0 ];
        logMsg += "' zeile '";
        logMsg += msg.begin()[ 1 ];
        logMsg += "' der Typ '";
        logMsg += msg.begin()[ 2 ];
        logMsg += "' der Variable '";
        logMsg += msg.begin()[ 3 ];
        logMsg += "' ist nicht definiert.";
        break;
    case 12:
        logMsg = "Error: Compile Fehler in Datei '";
        logMsg += msg.begin()[ 0 ];
        logMsg += "' zeile '";
        logMsg += msg.begin()[ 1 ];
        logMsg += "' der Typ '";
        logMsg += msg.begin()[ 2 ];
        logMsg += "' der Funktion '";
        logMsg += msg.begin()[ 3 ];
        logMsg += "' ist nicht definiert.";
        break;
    case 13:
        logMsg = "Error: Compile Fehler in Datei '";
        logMsg += msg.begin()[ 0 ];
        logMsg += "' zeile '";
        logMsg += msg.begin()[ 1 ];
        logMsg += "' der Befehl '";
        logMsg += msg.begin()[ 2 ];
        logMsg += "' konnte nicht ausgeweret werden.";
        break;
    case 14:
        logMsg = "Warnung: Compile Warnung in Datei '";
        logMsg += msg.begin()[ 0 ];
        logMsg += "' zeile '";
        logMsg += msg.begin()[ 1 ];
        logMsg += "' die Anzahl der Argumente stimmt nicht mit der Funktion berein.";
        break;
    case 15:
        logMsg = "Warnung: Der rckgabewert stimmt nicht mit dem Funktionstyp berein.";
        break;
    case 16:
        logMsg = "Warnung: Fehler beim konvertieren einer Variable.";
        break;
    case 17:
        logMsg = "Warnung: Zugriffsfehler auf private Variable.";
        break;
    case 18:
        logMsg = "Warnung: Zugriffsfehler auf private Funktion.";
        break;
    case 19:
        logMsg = "Warnung: Funktion konnte nicht gefunden werden.";
        break;
    case 20:
        logMsg = "Warnung: Es wurden nicht alle Parameter fr die Funktion angegeben.";
        break;
    case 21:
        logMsg = "Warnung: Der Operator konnte nicht gefunden werden.";
        break;
    case 22:
        logMsg = "Warnung: Ein Befehl konnte nicht richtig ausgefhrt werden.";
        break;
    }
    if( zObj )
        zObj->logNachricht( logMsg );
    std::cout << "KSGS " << (char *)logMsg << "\n";
}