#include "../Befehl/KSGSFunktion.h"

namespace KSGScript
{
    class KSGScriptObj;

    class KSGSCallbackInstanz : public KSGSFunktionInstanz
    {
    private:
        RCArray< KSGSVariable > *parameter;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSCallbackInstanz( KSGScriptObj *obj );
        // Destruktor
        __declspec( dllexport ) ~KSGSCallbackInstanz();
        // nicht constant
        __declspec( dllexport ) virtual void setParameter( Array< KSGSVariableDef * > *zDef, RCArray< KSGSVariable > *vars ) override;
        __declspec( dllexport ) virtual KSGSVariable *startFunktion() override;
    };

    class KSGSCallbackFunktion : public KSGSFunktion
    {
    public:
        // Konstruktor
        __declspec( dllexport ) KSGSCallbackFunktion();
        // nicht constant
        __declspec( dllexport ) virtual KSGSFunktionInstanz *erstellInstanz( KSGScriptObj *obj, KSGSVariable *klasse, RCArray< KSGSVariable > *params );
    };
}