#include <initializer_list>

#define lesen( x )
#define var
#define func

#define Rckruf( ... ) {}

class Array
{
public:
	void anhngen( ... );
	void einfgen( int i, ... );
	void set( int i, ... );
	void setPosition( int i, int p );
	void lsche( int i );
	void tausche( int a, int b );
	void leeren();
	int getEintragAnzahl();
	std::initializer_list get( int i );
	bool hat( int i );
};

class Thread
{
public:
	void pause();
	void fortsetzen();
	void ende();
	bool luft();
	int warteAufThread( int zeit );
};

class Text
{
public:
	Text();
	Text( char *txt );
	Text( int txt );
	Text( double txt );
	Text( bool txt );
	void setSuchGrenzen( int, int );
	void setText( Text t );
	void anhngen( Text t );
	void einfgen( int p, Text t );
	void ersetzen( int beg, int end, Text t );
	void lschen( int beg, int end );
	int getLnge();
	bool hat( Text t );
	bool istGleich( Text t );
	int anzahlVon( Text t );
	int positionVon( Text t, int n );
	Text getTeilText( int beg, int end );
	Text operator+=( char* );
};

class Bild
{
public:
	void neuBild( int br, int h, int f );
	void setAlpha( int a );
	void releaseAlpha();
	void alphaPixel( int x, int y, int f );
	void setPixel( int x, int y, int f );
	void alphaRegion( int x, int y, int br, int h, int f );
	void fllRegion( int x, int y, int br, int h, int f );
	void drawLinieAlpha( int xBeg, int yBeg, int xEnd, int yEnd, int f );
	void drawLinie( int xBeg, int yBeg, int xEnd, int yEnd, int f );
	void alphaBild( int x, int y, int br, int h, Bild b );
	void drawBild( int x, int y, int br, int h, Bild b );
	void alphaBild90( int x, int y, int br, int h, Bild b );
	void drawBild90( int x, int y, int br, int h, Bild b );
	void alphaBild180( int x, int y, int br, int h, Bild b );
	void drawBild180( int x, int y, int br, int h, Bild b );
	void alphaBild270( int x, int y, int br, int h, Bild b );
	void drawBild270( int x, int y, int br, int h, Bild b );
	bool setDrawOptions( int x, int y, int br, int h );
	bool setDrawOptionsErzwingen( int x, int y, int br, int h );
	bool addScrollOffset( int xScroll, int yScroll );
	void releaseDrawOptions();
	int getBreite();
	int getHhe();
	int getPixel( int x, int y );
};

class MausEreignis
{
public:
	int id;
	int mx;
	int my;
	int rmx;
	int rmy;
	bool verarbeitet;
	void setId( int id );
	void setMx( int mx );
	void setMy( int my );
	void setRmx( int rmx );
	void setRmy( int rmy );
	void setVerarbeitet( bool verarbeitet );
};

class TastaturEreignis
{
public:
	int id;
	int taste;
	bool verarbeitet;
	void setId( int id );
	void setTaste( int taste );
	void setVerarbeitet( bool verarbeitet );
};

class TextFeld
{
public:
	void setText( Text t );
	void addZeile( Text t );
	void setAuswahl( int beg, int end );
	void setHintergrundBild( Bild b );
	void setHintergrundFarbe( int f );
	void setSchriftGre( int gr );
	void setSchriftFarbe( int f );
	void setAFStrke( int s );
	void setAFFarbe( int f );
	void setLRBreite( int br );
	void setLRFarbe( int f );
	void setShowChar( int c );
	void setVKlickScroll( int vks );
	void setVScrollPosI( int sp );
	void setVScrollZuZeile( int sl );
	void updateVScroll();
	void setStyle( int s );
	void addStyle( int s );
	void lscheStyle( int s );
	bool tick( double z );
	void setMausEreignis( Text fName );
	void setTastaturEreignis( Text fName );
	void doMausEreignis( MausEreignis me );
	void doTastaturEreignis( TastaturEreignis te );
	void render( Bild b );
	Text getText();
	Bild getHintergrundBild();
	int getHintergrundFarbe();
	int getSchriftGre();
	int getSchriftFarbe();
	int getAFStrke();
	int getAFFarbe();
	int getLRBreite();
	int getLRFarbe();
	int getShowChar();
	bool hatStyle( int s );
	bool hatStyleNicht( int s );
	TextFeld dublizieren();
	void setToolTipText( Text t );
	void setPosition( int x, int y );
	void setGre( int br, int h );
	int getBreite();
	int getHhe();
	int getX();
	int getY();
	Text getToolTipText();
	void setGreNachText();
    void setTextNachGre();
};

class Knopf
{
public:
	void setText( Text t );
	void setHintergrundBild( Bild b );
	void setHintergrundFarbe( int f );
	void setSchriftGre( int gr );
	void setSchriftFarbe( int f );
	void setAFStrke( int s );
	void setAFFarbe( int f );
	void setLRBreite( int br );
	void setLRFarbe( int f );
	void setKlickFarbe( int f );
	void setKlickBild( Bild b );
	void setKBStrke( int s );
	void setKBFarbe( int f );
	void setStyle( int s );
	void addStyle( int s );
	void lscheStyle( int s );
	bool tick( double z );
	void setMausEreignis( Text fName );
	void doMausEreignis( MausEreignis me );
	void render( Bild b );
	Text getText();
	Bild getHintergrundBild();
	int getHintergrundFarbe();
	int getSchriftGre();
	int getSchriftFarbe();
	int getAFStrke();
	int getAFFarbe();
	int getLRBreite();
	int getLRFarbe();
	int getKlickFarbe();
	Bild getKlickBild();
	int getKBFarbe();
	int getKBStrke();
	bool hatStyle( int s );
	bool hatStyleNicht( int s );
	Knopf dublizieren();
	Text setToolTipText( Text t );
	void setPosition( int x, int y );
	void setGre( int br, int h );
	int getBreite();
	int getHhe();
	int getX();
	int getY();
	Text getToolTipText();
};

class Fenster
{
public:
	void setRFarbe( int f );
	void setRBreite( int br );
	void setTitel( Text t );
	void setTSFarbe( int f );
	void setTSGre( int gr );
	void setTBgFarbe( int f );
	void setTAfFarbe( int f );
	void setTAfStrke( int s );
	void setTBgBild( Bild b );
	void setTRFarbe( int f );
	void setTRBreite( int br );
	void setKBgFarbe( int f );
	void setKBgBild( Bild b );
	void setKAfFarbe( int f );
	void setKAfStrke( int s );
	void setSBgFarbe( int f );
	void setSBgBild( Bild b );
	void setSAfFarbe( int f );
	void setSAfStrke( int s );
	void setSKAfFarbe( int f );
	void setSKAfStrke( int s );
	void setMin( int minBr, int minH );
	void setMax( int maxBr, int maxH );
	void setKMin( int minBr, int minH );
	void setKMax( int maxBr, int maxH );
	void setHSBMax( int maxSBr );
	void setVSBMax( int maxH );
	void setHSBScroll( int sp );
	void setVSBScroll( int sp );
	void setStyle( int s );
	void addStyle( int s );
	void removeStyle( int s );
	void addMember( .../* Zeichnung */ );
	void removeMember( .../* Zeichnung */ );
	bool tick( double z );
	void setMausEreignis( Text fName );
	void setTastaturEreignis( Text fName );
	void doMausEreignis( MausEreignis me );
	void doTastaturEreignis( TastaturEreignis te );
	void render( Bild b );
	int getRFarbe();
	int getRBreite();
	Text getTitel();
	int getTSFarbe();
	int getTSGre();
	int getTBgFarbe();
	int getTAfFarbe();
	int getTAfStrke();
	Bild getTBgBild();
	int getTRFarbe();
	int getTRBreite();
	int getKBgFarbe();
	Bild getKBgBild();
	int getKAfFarbe();
	int getKAfStrke();
	int getSBgFarbe();
	Bild getSBgBild();
	int getSAfFarbe();
	int getSAfStrke();
	int getSKAfFarbe();
	int getSKAfStrke();
	int getMinBreite();
	int getMinHhe();
	int getMaxBreite();
	int getMaxHhe();
	int getKMinBreite();
	int getKMinHhe();
	int getKMaxBreite();
	int getKMaxHhe();
	bool hatStyle( int s );
	bool hatStyleNicht( int s );
	Fenster dublizieren();
	void setToolTipText( Text t );
	void setPosition( int x, int y );
	void setGre( int br, int h );
	int getBreite();
	int getHhe();
	int getX();
	int getY();
	Text getToolTipText();
};

class BildZ
{
public:
	void setBild( Bild b );
	void setRFarbe( int f );
	void setRBreite( int br );
	void setStyle( int s );
	void addStyle( int s );
	void lscheStyle( int s );
	bool tick( double z );
	void setMausEreignis( Text fName );
	void doMausEreignis( MausEreignis me );
	void render( Bild b );
	Bild getBild();
	bool hatStyle( int s );
	bool hatStyleNicht( int s );
	BildZ dublizieren();
	void setToolTipText( Text t );
	void setPosition( int x, int y );
	void setGre( int br, int h );
	int getBreite();
	int getHhe();
	int getX();
	int getY();
	Text getToolTipText();
};

class Animation2DData
{
public:
	void ladeAnimation( Text pf );
	void setFPS( int fps );
	void setWiederhohlend( bool w );
	void setTransparent( bool t );
	void reset();
	Bild getBild( int n );
	int getBildAnzahl();
	int getFPS();
	bool istWiederhohlend();
	bool istTransparent();
};

class Animation2D
{
public:
	void setRahmen( bool r );
	void setRahmenBreite( int br );
	void setRahmenFarbe( int f );
	void setAnimationData( Animation2DData d );
	void setAlphaMaske( int am );
	void setAPS( int aps );
	void setSichtbar( bool s );
	bool tick( double z );
	void render( Bild b );
	Animation2DData getAnimationData();
	bool istSichtbar();
	int getJetzt();
	int getAlphaMaske();
	bool hatRahmen();
	int getRahmenBreite();
	int getRahmenFarbe();
	void setToolTipText( Text t );
	void setPosition( int x, int y );
	void setGre( int br, int h );
	int getBreite();
	int getHhe();
	int getX();
	int getY();
	Text getToolTipText();
};