#ifndef KSGSAnimation2D_H
#define KSGSAnimation2D_H

#include "../Befehl/KSGSKlasse.h"
#include <Animation.h>
#include <MausEreignis.h>

namespace KSGScript
{
    class KSGSAnimation2DKlasse : public KSGSKlasseInstanz
    {
    private:
        Animation2D *val;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSAnimation2DKlasse( KSGScriptProcessor *zObj, Animation2D *std = new Animation2D() );
        // Destruktor
        __declspec( dllexport ) ~KSGSAnimation2DKlasse();
        // nicht constant
        __declspec( dllexport ) virtual KSGSVariable *startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter ) override;
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        // constant
        __declspec( dllexport ) virtual Animation2D *getVal() const;
        __declspec( dllexport ) virtual Animation2D *zVal() const;
    };
}

#endif