#ifndef KSGSFenster_H
#define KSGSFenster_H

#include "../Befehl/KSGSKlasse.h"
#include <Fenster.h>

namespace KSGScript
{
    class KSGSFensterKlasse : public KSGSKlasseInstanz
    {
    private:
        Fenster *val;
        int mausF;
        int tastaturF;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSFensterKlasse( KSGScriptProcessor *zObj, Fenster *std = new Fenster() );
        // Destruktor
        __declspec( dllexport ) ~KSGSFensterKlasse();
        // nicht constant
        __declspec( dllexport ) virtual KSGSVariable *startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter ) override;
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        __declspec( dllexport ) virtual bool doMausEreignis( MausEreignis &me );
        __declspec( dllexport ) virtual bool doTastaturEreignis( TastaturEreignis &te );
        // constant
        __declspec( dllexport ) virtual Fenster *getVal() const;
        __declspec( dllexport ) virtual Fenster *zVal() const;
    };

    // Ereignisse
    __declspec( dllexport ) bool ksgsFensterME( void *var, void *obj, MausEreignis me );
    __declspec( dllexport ) bool ksgsFensterTE( void *var, void *obj, TastaturEreignis te );
}

#endif