#ifndef KSGSInt_H
#define KSGSInt_H

#include "../Befehl/KSGSKlasse.h"

namespace KSGScript
{
    class KSGSIntKlasse : public KSGSKlasseInstanz
    {
    private:
        int val;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSIntKlasse( KSGScriptProcessor *zObj, int std = 0 );
        // Destruktor
        __declspec( dllexport ) ~KSGSIntKlasse();
        // nicht constant
        __declspec( dllexport ) void set( int i );
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        // constant
        __declspec( dllexport ) virtual int getVal() const;
        __declspec( dllexport ) virtual KSGSVariable *umwandelnIn( int typ ) const override;
    };
}

#endif