#ifndef KSGSKnopf_H
#define KSGSKnopf_H

#include "../Befehl/KSGSKlasse.h"
#include <Knopf.h>

namespace KSGScript
{
    class KSGSKnopfKlasse : public KSGSKlasseInstanz
    {
    private:
        Knopf *val;
        int mausF;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSKnopfKlasse( KSGScriptProcessor *zObj, Knopf *std = new Knopf() );
        // Destruktor
        __declspec( dllexport ) ~KSGSKnopfKlasse();
        // nicht constant
        __declspec( dllexport ) virtual KSGSVariable *startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter ) override;
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        __declspec( dllexport ) virtual bool doMausEreignis( MausEreignis &me );
        // constant
        __declspec( dllexport ) virtual Knopf *getVal() const;
        __declspec( dllexport ) virtual Knopf *zVal() const;
    };

    // Ereignisse
    __declspec( dllexport ) bool ksgsKnopfME( void *var, void *obj, MausEreignis me );
}

#endif