#ifndef KSGSMausEreignis_H
#define KSGSMausEreignis_H

#include "../Befehl/KSGSKlasse.h"
#include <MausEreignis.h>

namespace KSGScript
{
    class KSGSMausEreignisKlasse : public KSGSKlasseInstanz
    {
    private:
        MausEreignis val;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSMausEreignisKlasse( KSGScriptProcessor *zObj, MausEreignis std = { 0, 0, 0, 0, 1, 0, 0 } );
        // Destruktor
        __declspec( dllexport ) ~KSGSMausEreignisKlasse();
        // nicht constant
        __declspec( dllexport ) void set( MausEreignis &me );
        __declspec( dllexport ) virtual KSGSVariable *startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter ) override;
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        // constant
        __declspec( dllexport ) virtual KSGSVariable *getVariable( int id, bool zugriff ) const override;
        __declspec( dllexport ) virtual MausEreignis getVal() const;
    };
}

#endif