#ifndef KSGSTastaturEreignis_H
#define KSGSTastaturEreignis_H

#include "../Befehl/KSGSKlasse.h"
#include <TastaturEreignis.h>

namespace KSGScript
{
    class KSGSTastaturEreignisKlasse : public KSGSKlasseInstanz
    {
    private:
        TastaturEreignis val;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSTastaturEreignisKlasse( KSGScriptProcessor *zObj, TastaturEreignis std = { 0, 0, 0 } );
        // Destruktor
        __declspec( dllexport ) ~KSGSTastaturEreignisKlasse();
        // nicht constant
        __declspec( dllexport ) void set( TastaturEreignis &te );
        __declspec( dllexport ) virtual KSGSVariable *startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter ) override;
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        // constant
        __declspec( dllexport ) virtual KSGSVariable *getVariable( int id, bool zugriff ) const override;
        __declspec( dllexport ) virtual TastaturEreignis getVal() const;
    };
}

#endif