#ifndef KSGSText_H
#define KSGSText_H

#include "../Befehl/KSGSKlasse.h"

namespace KSGScript
{
    class KSGSTextKlasse : public KSGSKlasseInstanz
    {
    private:
        Text *val;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSTextKlasse( KSGScriptProcessor *zObj, const char *std = "" );
        // Destruktor
        __declspec( dllexport ) ~KSGSTextKlasse();
        // nicht constant
        __declspec( dllexport ) virtual KSGSVariable *startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter ) override;
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        // constant
        __declspec( dllexport ) virtual Text *getVal() const;
        __declspec( dllexport ) virtual Text *zVal() const;
        __declspec( dllexport ) virtual KSGSVariable *umwandelnIn( int typ ) const override;
    };
}

#endif