#ifndef KAGSThread_H
#define KAGSThread_H

#include "../Befehl/KSGSKlasse.h"

namespace KSGScript
{
    class KSGSThreadKlasse : public KSGSKlasseInstanz
    {
    private:
        KSGSFunktionInstanz *func;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSThreadKlasse( KSGScriptProcessor *zObj, KSGSFunktionInstanz *f );
        // Destruktor
        __declspec( dllexport ) ~KSGSThreadKlasse();
        // nicht constant
        __declspec( dllexport ) void threadEnde();
        __declspec( dllexport ) virtual KSGSVariable *startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter ) override;
    };
}

#endif