#include "KSGScriptObj.h"
#include "../Editor/Editor.h"
#include "../Befehl/KSGSKlasse.h"
#include "../Klassen/KSGSBild.h"
#include "../Main/KSGSExpressionEvaluator.h"

using namespace KSGScript;

extern "C"
{
    __declspec( dllexport ) KSGScriptObj *GetNewKSGScriptObj()
    {
        return new KSGScriptO();
    }

    __declspec( dllexport ) KSGScriptEditor *GetNewKSGEditorObj()
    {
        return new Editor();
    }

    __declspec( dllexport ) KSGSVariable *GetNewKSGSVariable( KSGScriptObj *zObj, KSGSVariableDef *def )
    {
        return KSGSKlasseInstanz::erstellVariable( zObj, def );
    }

    __declspec( dllexport ) KSGSExpressionEvaluator *GetNewKSGSExpressionEvaluator()
    {
        return new KSGSExpressionEvaluatorImpl();
    }
    __declspec( dllexport ) void SetKSGSBildVariable( KSGSVariable *zBv, Bild *b )
    {
        if( !b )
            return;
        if( zBv->getTyp() != KSGS_BILD )
        {
            b->release();
            return;
        }
        ( (KSGSBildKlasse *)zBv )->set( b );
    }
}