#ifndef KSGSAnimation2DData_H
#define KSGSAnimation2DData_H

#include "../Befehl/KSGSKlasse.h"
#include <Animation.h>

namespace KSGScript
{
    class KSGSAnimation2DDataKlasse : public KSGSKlasseInstanz
    {
    private:
        Animation2DData *val;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSAnimation2DDataKlasse( KSGScriptProcessor *zObj, Animation2DData *std = new Animation2DData() );
        // Destruktor
        __declspec( dllexport ) ~KSGSAnimation2DDataKlasse();
        // nicht constant
        __declspec( dllexport ) virtual KSGSVariable *startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter ) override;
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        // constant
        __declspec( dllexport ) virtual Animation2DData *getVal() const;
        __declspec( dllexport ) virtual Animation2DData *zVal() const;
    };
}

#endif