#ifndef KSGSArray_H
#define KSGSArray_H

#include "../Befehl/KSGSKlasse.h"
#include <Array.h>

namespace KSGScript
{
    class KSGSArrayKlasse : public KSGSKlasseInstanz
    {
    private:
        RCArray< KSGSVariable > *val;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSArrayKlasse( KSGScriptProcessor *zObj, RCArray< KSGSVariable > *std = new RCArray< KSGSVariable >() );
        // Destruktor
        __declspec( dllexport ) ~KSGSArrayKlasse();
        // nicht constant
        __declspec( dllexport ) virtual KSGSVariable *startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter ) override;
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        // constant
        __declspec( dllexport ) virtual RCArray< KSGSVariable > *getVal() const;
        __declspec( dllexport ) virtual RCArray< KSGSVariable > *zVal() const;
    };
}

#endif