#ifndef KSGSBild_H
#define KSGSBild_H

#include "../Befehl/KSGSKlasse.h"
#include <Bild.h>

namespace KSGScript
{
    class KSGSBildKlasse : public KSGSKlasseInstanz
    {
    private:
        Bild *val;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSBildKlasse( KSGScriptProcessor *zObj, Bild *std = new Bild() );
        // Destruktor
        __declspec( dllexport ) ~KSGSBildKlasse();
        // nicht constant
        __declspec( dllexport ) void set( Bild *b );
        __declspec( dllexport ) virtual KSGSVariable *startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter ) override;
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        // constant
        __declspec( dllexport ) virtual Bild *getVal() const;
        __declspec( dllexport ) virtual Bild *zVal() const;
    };
}

#endif