#ifndef KSGSBildZ_H
#define KSGSBildZ_H

#include "../Befehl/KSGSKlasse.h"
#include <Bild.h>
#include <MausEreignis.h>

namespace KSGScript
{
    class KSGSBildZKlasse : public KSGSKlasseInstanz
    {
    private:
        BildZ *val;
        int mausF;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSBildZKlasse( KSGScriptProcessor *zObj, BildZ *std = new BildZ() );
        // Destruktor
        __declspec( dllexport ) ~KSGSBildZKlasse();
        // nicht constant
        __declspec( dllexport ) virtual KSGSVariable *startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter ) override;
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        __declspec( dllexport ) virtual bool doMausEreignis( MausEreignis &me );
        // constant
        __declspec( dllexport ) virtual BildZ *getVal() const;
        __declspec( dllexport ) virtual BildZ *zVal() const;
    };

    // Ereignisse
    __declspec( dllexport ) bool ksgsBildZME( void *var, void *obj, MausEreignis me );
}

#endif