#ifndef KSGSBool_H
#define KSGSBool_H

#include "../Befehl/KSGSKlasse.h"

namespace KSGScript
{
    class KSGSBoolKlasse : public KSGSKlasseInstanz
    {
    private:
        bool val;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSBoolKlasse( KSGScriptProcessor *zObj, bool std = 0 );
        // Destruktor
        __declspec( dllexport ) ~KSGSBoolKlasse();
        // nicht constant
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        // constant
        __declspec( dllexport ) virtual bool getVal() const;
        __declspec( dllexport ) virtual KSGSVariable *umwandelnIn( int typ ) const override;
    };
}

#endif