#ifndef KSGSDouble_H
#define KSGSDouble_H

#include "../Befehl/KSGSKlasse.h"

namespace KSGScript
{
    class KSGSDoubleKlasse : public KSGSKlasseInstanz
    {
    private:
        double val;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSDoubleKlasse( KSGScriptProcessor *zObj, double std = 0 );
        // Destruktor
        __declspec( dllexport ) ~KSGSDoubleKlasse();
        // nicht constant
        __declspec( dllexport ) void set( double d );
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        // constant
        __declspec( dllexport ) virtual double getVal() const;
        __declspec( dllexport ) virtual KSGSVariable *umwandelnIn( int typ ) const override;
    };
}

#endif