#pragma once

// Klassen
// Entspricht der Definitionsreihenfolge im Konstruktor der KSGSCompKlassTable Klasse aus KSGSCompile.h
#define KSGS_TYP_MIN          0

#define KSGS_VOID			  0
#define KSGS_BOOL			  1
#define KSGS_INT              2
#define KSGS_DOUBLE			  3
#define KSGS_ARRAY            4
#define KSGS_THREAD			  5
#define KSGS_TEXT			  6
#define KSGS_BILD			  7
#define KSGS_MAUSEREIGNIS     8
#define KSGS_TASTATUREREIGNIS 9
#define KSGS_TEXTFELD         10
#define KSGS_KNOPF            11
#define KSGS_FENSTER          12
#define KSGS_BILDO            13
#define KSGS_ANIMATION2DDATA  14
#define KSGS_ANIMATION2D      15

#define KSGS_TYP_MAX          15

// Operatoren

#define KSGS_O_TYP_MIN        0

#define KSGS_O_SET            0
#define KSGS_O_PLUSSET        1
#define KSGS_O_MINUSSET       2
#define KSGS_O_MAHLSET        3
#define KSGS_O_GETEILTSET     4
#define KSGS_O_UNDSET         5
#define KSGS_O_ODERSET        6
#define KSGS_O_GLEICH         7
#define KSGS_O_KLEINERGLEICH  8
#define KSGS_O_GREATERGLEICH   9
#define KSGS_O_UNGLEICH       10
#define KSGS_O_KLEINER        11
#define KSGS_O_GREATER         12
#define KSGS_O_ODER           13
#define KSGS_O_UND            14
#define KSGS_O_BITODER        15
#define KSGS_O_BITUND         16
#define KSGS_O_PLUS           17
#define KSGS_O_MINUS          18
#define KSGS_O_MAHL           19
#define KSGS_O_GETEILT        20
#define KSGS_O_REST           21
#define KSGS_O_PLUS1          22
#define KSGS_O_MINUS1         23
#define KSGS_O_NICHT          24
#define KSGS_O_BITNICHT       25
#define KSGS_O_NACHLINKS      26
#define KSGS_O_NACHRECHTS     27

#define KSGS_O_TYP_MAX        27